#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <mih/cipher.h>

int main(void)
{
    char               data_to_hash[30]  = "Keep this very, very secret !";
    char               md5_work_area[96] = "";
    _CIPHER_Control_T5 md5_opts, *p_md5_opts;
    char               hash[16];
    int                dummy = 0;
    _SPCPTR            receiver, source;

    memset( &md5_work_area, 0, sizeof(md5_work_area) );
    memset( &md5_opts.Output, 0, sizeof(md5_opts.Output) );
    memset( &md5_opts.Reserved, 0, sizeof(md5_opts.Reserved) );

    md5_opts.Func_ID    = ONE_WAY_HASH;
    md5_opts.Hash_Algor = MD5;
    md5_opts.Sequence   = ONLY;
    md5_opts.Data_Len   = strlen(data_to_hash);
    md5_opts.Hash_Context = md5_work_area;

    p_md5_opts = &md5_opts;
    receiver   = hash;
    source     = data_to_hash;

    _CIPHER( &receiver, p_md5_opts, &source );

    printf("Hash for %s = %s\n", data_to_hash, hash);

    return 0;
}
